<?php
/***************************************************************************
*                             radio_status.php
*                            -------------------
*   begin                : Feb 2005
*   copyright            : (C) 2005 UseLess
*   email                : 
*   last modified        : 15/02/2005
*   version              : 1.0.3
*   requires		 : shoutcastinfo.php (class file)
***************************************************************************/

/***************************************************************************
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
***************************************************************************/

//
// Start User configuration
//
$radio_host = "www.radio-host.com";
$radio_port = 8500;
$radio_timeout = 5;

$radio_listen_ampfile = 'listen.pls';
$radio_listen_wmpfile = 'listen.m3u';

$radio_irc = 'irc://radio-host.com';
$radio_irc_channel = '#radio';
//
// End User Configuration
//

$radio_version = '1.0.3';

$radio_listen = 'http://' . $radio_host . ':' . $radio_port . '/' . $radio_listen_ampfile;
$radio_listen_wmp = 'http://' . $radio_host . '/' . $radio_listen_wmpfile;
$radio_irc_join = $radio_irc . $radio_irc_channel;

//
// setup small language array
//
$radio_lang = array();

$radio_lang['radio_title'] = 'Radio';
$radio_lang['radio_status'] = 'Radio est';
$radio_lang['radio_noton'] = 'El Servicio de Radio no est en funcionamiento';
$radio_lang['radio_offline'] = 'DJ Required';
$radio_lang['radio_online'] = 'On-line';
$radio_lang['radio_track'] = 'Cancin actual';
$radio_lang['radio_listeners'] = 'Oyentes';
$radio_lang['radio_listen_peak'] = 'Our Peak';
$radio_lang['radio_dj'] = 'DJ';
$radio_lang['radio_irc'] = 'IRC';
$radio_lang['radio_request_title'] = 'Peticiones';
$radio_lang['radio_requests'] = 'Aqui..';
$radio_lang['radio_requests_no'] = 'N/A';

//
// Load required file
//
require('shoutcastinfo.php');

$gr = new shoutcast_info($radio_host, $radio_port, $radio_timeout);

$template->set_filenames(array('radio' => 'radio_body.tpl'));

$radio_is_on = false;
$radio_error = false;

if ( !$gr->connect() )
{
	//list($errno, $errstr) = $gr->error();
	$radio_status = $radio_lang['radio_offline'];
	$radio_status_title = $radio_lang['radio_noton'];
	$radio_dj = '';
	$radio_track = '';
	$radio_listeners = '0';
	$radio_listen_max = '-'; 
	$radio_peak = '-';
	$radio_class = 'navradioff';
	$radio_listen = '#';
	$radio_url = 'none';
	$radio_requests = '#';

	$radio_error = true;
}

if( !$radio_error )
{
	$gr->send();
	
	if( !$gr->get_stat() )
	{
		$radio_status = $radio_status_tile = $radio_lang['radio_offline'];
		$radio_listen_select = $radio_status;
		$radio_dj = '';
		$radio_track = '';
		$radio_listeners = '0';
		$radio_listen_max = '-'; 
		$radio_peak = '-';
		$radio_url = 'none';
		$radio_requests = '#';
		$radio_class = 'navradioff';
	}
	else
	{
		$radio_dj = $gr->get_title();
		$radio_tmp = trim(substr($radio_dj, strpos($radio_dj, ':') + 1));
		
		if(preg_match('/\bdj\b/i', $radio_tmp))
		{
			$radio_dj = preg_replace("/\bdj\b/i", "DJ", $radio_tmp);
		}
		else
		{
			$radio_dj = 'DJ ' . $radio_tmp;
		}

		$radio_status = $radio_lang['radio_online']  . ' (' . trim(substr($radio_dj, strpos($radio_dj, ':'))) . ')';
		$radio_status_title = $radio_lang['radio_online'];
		$radio_track = $gr->get_track();
		$radio_listeners = $gr->get_listener();
		$radio_listen_max = $gr->get_parsed_value('listener_max');
		$radio_peak = $gr->get_peak();
		$radio_class = 'navradion';
		$radio_url = $gr->get_url();
		$radio_requests = ( $radio_url != 'none' ) ? $radio_url : '#';
		
		$radio_listen_select = '<select name="dummy" size="1" onchange="if (this.options[this.selectedIndex].value != -1) {window.open(this.options[this.selectedIndex].value);};" style="width: 75px;">';
		$radio_listen_select .= '<option value="-1">' . $radio_status_title . '</option>';
		$radio_listen_select .= '<option value="' . $radio_listen . '">WinAMP</option>';
		$radio_listen_select .= '<option value="' . $radio_listen_wmp . '">WMP</option>';
		$radio_listen_select .= '</select>';
		
		$radio_is_on = true;
	}
	

	$gr->close();
}

//
// Assign values to template
//
$template->assign_vars(array(
	'RADIO_TITLE' => $radio_lang['radio_title'],
	'RADIO_STATUS_TITLE' => $radio_lang['radio_status'],
	'RADIO_DJ_TITLE' => $radio_lang['radio_dj'],
	'RADIO_TRACK_TITLE' => $radio_lang['radio_track'],
	'RADIO_LISTENERS_TITLE' => $radio_lang['radio_listeners'],
	'RADIO_LISTENERS_PEAK_TITLE' => $radio_lang['radio_listen_peak'],
	'RADIO_IRC_TITLE' => $radio_lang['radio_irc'],
	'RADIO_REQUEST_TITLE' => $radio_lang['radio_request_title'],
	'RADIO_REQUESTS' => (( $radio_url != 'none') ? $radio_lang['radio_requests'] : $radio_lang['radio_requests_no']),

	'RADIO_STATUS' => $radio_status,
	'RADIO_DJ' => $radio_dj,
	'RADIO_TRACK' => $radio_track,
	'RADIO_LISTENERS' => $radio_listeners,
	'RADIO_LISTENERS_MAX' => $radio_listen_max,
	'RADIO_LISTENERS_PEAK' => $radio_peak,

	'RADIO_CLASS' => $radio_class,

	'U_RADIO_IRC' => $radio_irc_join,
	'U_RADIO_REQUESTS' => $radio_requests,
	'RADIO_LISTEN' => $radio_listen_select,

	'RADIO_VERSION' => $radio_version
));

$template->assign_var_from_handle('RADIO_STATUS', 'radio');	

?>